#Region INCLUDES
#Include 'Resources\Header.au3'
#Include 'IE.au3'
#Endregion

#Region Options
Opt( 'GUIOnEventMode', 1 )
#Endregion

#Region VARIABLES
Global Const $_VERSION = 'v0.2'
Global Const $_NAME = 'KMLI'
Global $_LOOP = True
Global $lPath, $lRead = '', $lCheck = False, $lCheck2 = False
Global $__TITLE = $_NAME & ' ' & $_VERSION & ' by Daniel W.' ;Titel fr Label in OptionsGUI
Global $_TITLE = $_NAME & ' ' & $_VERSION & ' by Daniel W.' ;Titel fr main_GUI
Global $_main_GUI_Size  = _InitializeGuiSize()
#Endregion

_main( $CmdLine )

Func _main( $aParameter )
	Local $lSkipLoad = False
	Local $lUpdate = False
	If $aParameter[0] > 0 Then
		For $lPar = 1 to $aParameter[0]
			If $aParameter[$lPar] = '/SkipLoad' Then $lSkipLoad = True
			If $aParameter[$lPar] = '/Update' Then $lUpdate = True
		Next 
	EndIf
;~ 	If $lUpdate Then _Update()
	If Not $lSkipLoad Then _load_GUI_Create()
	_main_GUI_Create()
	_options_GUI_Create()
	While $_LOOP
		_main_GUI_Tab_Refresh()
		_main_GUI_Tab_Quelltext_SetName()
		Sleep( 100 )
	WEnd
EndFunc

Func _main_GUI_Create()
	$main_GUI = GUICreate( $_TITLE, $_main_GUI_Size[1], $_main_GUI_Size[2], 0, 0 )

	_main_GUI_Create_Toolbar( $_main_GUI_Size, $_TITLE )	
	$main_GUI_Tab = GUICtrlCreateTab( 5, 55, $_main_GUI_Size[1] - 10, $_main_GUI_Size[2] - 60 )
	$main_GUI_Tab_Quelltext_Tab = GUICtrlCreateTabItem( 'HTML-Quelltext' )
	$main_GUI_Tab_Quelltext_Edit = GUICtrlCreateEdit( '', 10, 85, $_main_GUI_Size[1] - 25, $_main_GUI_Size[2] - 100,BitOR($ES_AUTOVSCROLL, $WS_VSCROLL, $ES_MULTILINE, $WS_HSCROLL, $ES_NOHIDESEL))
	$main_GUI_Tab_Site_Tab = GUICtrlCreateTabItem( 'HTML-Seite' )
	_IEErrorHandlerRegister()
	$oIE = _IECreateEmbedded()
	$main_GUI_Tab_Site_Object = GUICtrlCreateObj( $oIE, 10, 85, $_main_GUI_Size[1] - 25, $_main_GUI_Size[2] - 100 )
	_InitializeIni()
	
	GUISetOnEvent( $GUI_EVENT_CLOSE, '_Exit' )

	GUISetState( @SW_SHOW, $main_GUI )
EndFunc

Func _options_GUI_Create()
	$options_GUI = GUICreate( 'Options', 368, 373, Default, Default, Default, $WS_EX_TOOLWINDOW )
	
	$options_GUI_Tab = GUICtrlCreateTab( 5, 5, 358, 363 )
	_options_GUI_Create_Informationen_Tab()
	_options_GUI_Create_Einstellungen_Tab()
	_options_GUI_Create_FTP_Tab()
	
	GUISetOnEvent( $GUI_EVENT_CLOSE, '_options_GUI_Exit' )
	
	GUISetState( @SW_HIDE )
EndFunc