#include-once

#Include 'GuiConstants.au3'
#Include 'GuiTab.au3'
#include 'GuiEdit.au3'
#Include 'GuiOnEvent.au3'
#Include 'String.au3'

Local $main_GUI_Tab, $lCheck2, $lRead, $lTemp, $lPath, $main_GUI_Tab_Quelltext_Edit, $oIE, $lCheck, $main_GUI_Tab_Quelltext_Tab, $__TITLE, $_TITLE

Func _load_GUI_Create()
	Local $load_GUI = GUICreate( "", 500, 300, Default, Default, $WS_POPUP )
	GUICtrlCreatePic( @ScriptDir & '\Resources\_load_GUI.jpg', 0, 0, 500, 280 )
	Local $lProgress = GUICtrlCreateProgress( 0, 280, 500, 20 )
	GUISetState()
	For $lNum = 0 to 100
		GUICtrlSetData( $lProgress, $LNum )
		Sleep( 10 )
	Next
	GUIDelete( $load_GUI )
EndFunc

Func _options_GUI_Create_FTP_Tab()
	$options_GUI_Tab_FTP = GUICtrlCreateTabItem( 'FTP-Einstellungen' )
	$options_GUI_Tab_FTP_Server_Label = GUICtrlCreateLabel( 'Servername:', 30, 50, 110, 20 )
	GUICtrlSetFont( -1, 10, 1200, 4 )
	$options_GUI_Tab_FTP_User_Label = GUICtrlCreateLabel( 'Username:', 30, 90, 110, 20 )
	GUICtrlSetFont( -1, 10, 1200, 4 )
	$options_GUI_Tab_FTP_PW_Label = GUICtrlCreateLabel( 'Passwort:', 30, 130, 110, 20 )
	GUICtrlSetFont( -1, 10, 1200, 4 )
	$options_GUI_Tab_FTP_Server_Input = GUICtrlCreateInput( IniRead( @ScriptDir & '\Resources\Settings.ini', 'Settings', 'Server', '' ), 170, 50, 110, 20 )
	$options_GUI_Tab_FTP_User_Input = GUICtrlCreateInput( IniRead( @ScriptDir & '\Resources\Settings.ini', 'Settings', 'Username', '' ), 170, 90, 110, 20 )
	$options_GUI_Tab_FTP_PW_Input = GUICtrlCreateInput( _StringEncrypt( 0, IniRead( @ScriptDir & '\Resources\Settings.ini', 'Settings', 'Passwort', '' ), 'passwort' ), 170, 130, 110, 20);, $ES_PASSWORD )
	$options_GUI_Tab_FTP_Save = GUICtrlCreateIcon( 'shell32.dll', 4, 170, 170 )
	$options_GUI_Tab_FTP_Upload = GUICtrlCreateIcon( 'shell32.dll', 14, 240, 170 ) 
	GUICtrlSetTip( $options_GUI_Tab_FTP_Save, 'FTP-Daten speichern' )
	GUICtrlSetTip( $options_GUI_Tab_FTP_Upload, 'Auf FTP hochladen' )
	GUICtrlSetOnEvent( $options_GUI_Tab_FTP_Save, '_options_GUI_Tab_FTP_Save' )
	GUICtrlSetOnEvent( $options_GUI_Tab_FTP_Upload, '_options_GUI_Tab_FTP_Upload' )
EndFunc

Func _options_GUI_Create_Informationen_Tab()
	$options_GUI_Tab_About = GUICtrlCreateTabItem( 'Informationen' )
	GUICtrlCreateLabel( $__TITLE & @CRLF & @CRLF & @CRLF & 'Credits:' & @CRLF & @CRLF & 'Everyone from' & @CRLF & 'www.autoit.de' & @CRLF & 'and' & @CRLF & ' www.autoitscript.com' & @CRLF & @CRLF & @CRLF & 'Contact me at:' & @CRLF & @CRLF & 'danielwahlmann at web dot de', 10, 50, 348, 353, $SS_CENTER )
	GUICtrlSetColor( -1, 0x0000FF )
	GUICtrlSetFont( -1, 12, 1200 )	
EndFunc

Func _options_GUI_Create_Einstellungen_Tab()
	$options_GUI_Tab_Options = GUICtrlCreateTabItem( 'Allgemeine Einstellungen' )
	$options_GUI_Tab_Options_Size_Label = GUICtrlCreateLabel( 'Schriftgre:', 30, 50, 110, 20 )
	GUICtrlSetFont( -1, 10, 1200, 4 )
	$options_GUI_Tab_Options_Art_Label = GUICtrlCreateLabel( 'Schriftart:', 30, 90, 110, 20 )
	GUICtrlSetFont( -1, 10, 1200, 4 )
	$options_GUI_Tab_Options_Typ_Label = GUICtrlCreateLabel( 'Schriftattribute:', 30, 130, 110, 20 )
	GUICtrlSetFont( -1, 10, 1200, 4 )
	$options_GUI_Tab_Options_Color_Label = GUICtrlCreateLabel( 'Schriftfarbe:', 30, 170, 110, 20 )
	GUICtrlSetFont( -1, 10, 1200, 4 )
	$options_GUI_Tab_Options_Size_Combo = GUICtrlCreateCombo( IniRead( @ScriptDir & '\Resources\Settings.ini', 'Font', 'Size', '9' ), 170, 50, 100, 20 )
	GUICtrlSetData( -1, '10|12|14|16|18|20|22' )
	$options_GUI_Tab_Options_Art_Combo = GUICtrlCreateCombo( IniRead( @ScriptDir & '\Resources\Settings.ini', 'Font', 'Art', 'MS Sans Serif' ), 170, 90, 100, 20  )
	GUICtrlSetData( -1, 'Arial|Courier|Courier New|Lucida Console|MS Sans Serif|MS Serif|Times New Roman' )
	$options_GUI_Tab_Options_Typ_Combo_Italic = GUICtrlCreateCheckbox( 'Kursiv', 170, 130, 50, 20 ) 
	GUICtrlSetFont( -1, Default, Default, 2 )
	$options_GUI_Tab_Options_Typ_Combo_Underlined = GUICtrlCreateCheckbox( 'Unterstrichen', 230, 130, 100, 20 )
	GUICtrlSetFont( -1, Default, Default, 4 )
	If StringInStr( IniRead( @ScriptDir & '\Resources\Settings.ini', 'Font', 'Typ', '' ) , '2' ) Then
		GUICtrlSetState( $options_GUI_Tab_Options_Typ_Combo_Italic, $GUI_CHECKED )
	EndIf
	If StringInStr( IniRead( @ScriptDir & '\Resources\Settings.ini', 'Font', 'Typ', '' ) , '4' ) Then
		GUICtrlSetState( $options_GUI_Tab_Options_Typ_Combo_Underlined, $GUI_CHECKED )
	EndIf
	$options_GUI_Tab_Options_Color_Edit = GUICtrlCreateInput( IniRead( @ScriptDir & '\Resources\Settings.ini', 'Font', 'Color', '0x000000' ), 170, 170, 150, 20 )
	$options_GUI_Tab_Options_Save = GUICtrlCreateIcon( 'shell32.dll', 4, 250, 210 )
	GUICtrlSetTip( $options_GUI_Tab_Options_Save, 'Einstellungen speichern' )
	GUICtrlSetOnEvent( $options_GUI_Tab_Options_Save, '_options_GUI_Tab_Options_Save' )	
EndFunc

Func _InitializeIni()
	$lIni = IniRead( @ScriptDir & '\Resources\Settings.ini', 'Settings', 'LastFile', '' )
	If FileExists( $lIni ) Then
		$lRead = FileRead( $lIni )
		GUICtrlSetData( $main_GUI_Tab_Quelltext_Edit, $lRead )
		WinSetTitle ( $_TITLE, '', $lIni )
		$_TITLE = $lIni
	EndIf
	_main_GUI_Set_Font()
EndFunc

Func _main_GUI_Set_Font()
	$lEdit_Size = IniRead( @ScriptDir & '\Resources\Settings.ini', 'Font', 'Size', '9' )
	$lEdit_Art = IniRead( @ScriptDir & '\Resources\Settings.ini', 'Font', 'Art', 'MS Sans Serif' )
	$lEdit_Typ = IniRead( @ScriptDir & '\Resources\Settings.ini', 'Font', 'Typ', Default )
	$lEdit_Color = IniRead( @ScriptDir & '\Resources\Settings.ini', 'Font', 'Color', '0x000000' )
	GUICtrlSetFont( $main_GUI_Tab_Quelltext_Edit, $lEdit_Size, Default, Execute($lEdit_Typ), $lEdit_Art )
	GUICtrlSetColor( $main_GUI_Tab_Quelltext_Edit, $lEdit_Color )
EndFunc

Func _main_GUI_Tab_Quelltext_SetName()
		If  $lRead <> GUICtrlRead( $main_GUI_Tab_Quelltext_Edit ) and $lCheck = False Then
			GUICtrlSetData( $main_GUI_Tab_Quelltext_Tab, 'HTML-Quelltext*' )
			$lCheck = True
		ElseIf $lCheck = True and $lRead = GUICtrlRead( $main_GUI_Tab_Quelltext_Edit ) Then
			GUICtrlSetData( $main_GUI_Tab_Quelltext_Tab, 'HTML-Quelltext' )
			$lCheck = False			
		EndIf	
EndFunc

Func _main_GUI_Tab_Refresh()
	If _GUICtrlTabGetCurSel( $main_GUI_Tab ) = 0 and $lCheck2 = True Then
		$lCheck2 = False
	ElseIf _GUICtrlTabGetCurSel( $main_GUI_Tab ) = 1 and $lCheck2 = False Then
		$lCheck2 = True
		If $lRead <> GUICtrlRead( $main_GUI_Tab_Quelltext_Edit ) Then
			$lTemp = @TempDir &  '\' & _UniquePCCode() & '.html'
			If FileExists( $lTemp ) Then
				FileDelete( $lTemp )
			EndIf
			FileWrite( $lTemp, GUICtrlRead( $main_GUI_Tab_Quelltext_Edit ) )
			$oIE.navigate( $lTemp )
		ElseIf $lRead = GUICtrlRead( $main_GUI_Tab_Quelltext_Edit ) Then
			$oIE.navigate( $lPath )
		EndIf
	EndIf
EndFunc

Func _InitializeGuiSize()
	Local $lReturn[3] = [ 2, @DesktopWidth - 5, @DesktopHeight - 62]
	Return $lReturn
EndFunc

Func _main_GUI_Create_Toolbar( $aSize, $aTitle )
	
	$main_GUI_Toolbar_Background = GUICtrlCreateLabel( "", 5, 5, $aSize[1] - 10, 40, $SS_SUNKEN + $SS_BLACKFRAME )
	GUICtrlSetState( $main_GUI_Toolbar_Background, $GUI_DISABLE )
	
	$main_GUI_Toolbar_Sign = GUICtrlCreateLabel( $aTitle, 395, 15, $aSize[1] - 410, 20, $SS_RIGHT )
	GUICtrlSetColor( $main_GUI_Toolbar_Sign, 0x0000FF )
	GUICtrlSetFont( $main_GUI_Toolbar_Sign, 12, 1200 )
	
	$main_GUI_Toolbar_New = GUICtrlCreateIcon( 'shell32.dll', 152, 10, 10 )
	$main_GUI_Toolbar_Open = GUICtrlCreateIcon( 'shell32.dll', 5, 50, 10 )
	$main_GUI_Toolbar_Save = GUICtrlCreateIcon( 'shell32.dll', 4, 90, 10 )

	$main_GUI_Toolbar_Find = GUICtrlCreateIcon( 'shell32.dll', 23, 135, 10 )
	$main_GUI_Toolbar_FindReplace = GUICtrlCreateIcon( 'shell32.dll', 46, 175, 10 )
	
	$main_GUI_Toolbar_ChangeView = GUICtrlCreateIcon( 'shell32.dll', 22, 220, 10 )
	
	$main_GUI_Toolbar_Options = GUICtrlCreateIcon( 'shell32.dll', 36, 265, 10 )

	GUICtrlSetTip( $main_GUI_Toolbar_New, 'Neu' )
	GUICtrlSetTip( $main_GUI_Toolbar_Open, 'ffne' )
	GUICtrlSetTip( $main_GUI_Toolbar_Save, 'Speichern' )
	GUICtrlSetTip( $main_GUI_Toolbar_Find, 'Suche' )
	GUICtrlSetTip( $main_GUI_Toolbar_FindReplace, 'Suche & Ersetze' )
	GUICtrlSetTip( $main_GUI_Toolbar_ChangeView, 'ndere Ansicht' )
	GUICtrlSetTip( $main_GUI_Toolbar_Options, 'Einstellungen' )
	
	GUICtrlSetOnEvent( $main_GUI_Toolbar_New, '_main_GUI_Toolbar_New_Pressed' )
	GUICtrlSetOnEvent( $main_GUI_Toolbar_Open, '_main_GUI_Toolbar_Open_Pressed' )
	GUICtrlSetOnEvent( $main_GUI_Toolbar_Save, '_main_GUI_Toolbar_Save_Pressed' )
	GUICtrlSetOnEvent( $main_GUI_Toolbar_Find, '_main_GUI_Toolbar_Find_Pressed' )
	GUICtrlSetOnEvent( $main_GUI_Toolbar_FindReplace, '_main_GUI_Toolbar_FindReplace_Pressed' )
	GUICtrlSetOnEvent( $main_GUI_Toolbar_ChangeView, '_main_GUI_Toolbar_ChangeView_Pressed' )
	GUICtrlSetOnEvent( $main_GUI_Toolbar_Options, '_main_GUI_Toolbar_Options_Pressed' )
EndFunc

Func _Encrypt( $aString , $aPW, $aMode = 1 )	
	Local $lReturn = "",$lBuffer = "", $lPW = "", $lStrLen = StringLen( $aString ), $lPwLen = StringLen( $aPW )
	If Not IsString( $aString ) or $lStrLen < 1 or ($aMode <> 0 and $aMode <> 1 ) or ($aMode = 0 and Mod( $aString, 2 ) <> 0 ) or StringLen( $aPW ) < 1 Then Return 0
	For $lNum = 1 to $lPwLen
		$lPW &= Asc( StringMid( $aPW , $lNum, 1 ) )
	Next
	Switch $aMode			
		Case 1
			For $lNum = 1 to $lStrLen
				$lReturn &=  Hex( BitXOR( BitNOT( Asc( StringMid( $aString, $lNum, 1 ) ) + 1 ), $lPW, 255 ), 2 )
			Next
		Case 0
			For $lNum = 1 To $lStrLen
				$lBuffer &= Chr( BitXOR( BitNOT( Asc ( Chr( Dec( StringMid( $aString, $lNum, 1 ) & StringMid( $aString, $lNum + 1, 1 ) ) ) ) ), $lPW, 255 ) )
				$lNum += 1
			Next
			For $lNum = 1 to $lStrLen/2
				$lReturn &=  Chr( Asc( StringMid( $lBuffer, $lNum, 1 ) ) - 1 )
			Next
	EndSwitch
	Return $lReturn
EndFunc

Func _UniquePCCode()
    Local $return , $first
    Local $pass = @ComputerName
    $encrypt = _StringEncrypt( $pass , $pass, 1 ) & @OSLang & @OSTYPE & @OSVersion & @OSServicePack & DriveGetSerial("C:\")
    $split = StringSplit( $encrypt , "a|b|c|d|e|f|g|h|i|j|k|l|m|n|o|p|q|r|s|t|u|v|w|x|y|z" )
    For $a = 1 to $split[0]
        For $b = 65 to 90
            If StringInStr( $split[$a] , Chr($b) ) Then
                $split[$a] = StringReplace( $split[$a] , Chr($b), $b )
            EndIf
        Next
        $first &= $split[$a]
    Next
    StringStripWS( $first , 8 )
    $split1 = StringSplit( $first , "_" )
    For $d = 1 to $split1[0]
        $return &= $split[$d]
    Next
    $return = StringMid(  $return ,  StringLen( $return ) / 2 - 3 , 8 )
    $second = Hex($return)
    $return = ""
    $split = StringSplit( $second , "a|b|c|d|e|f|g|h|i|j|k|l|m|n|o|p|q|r|s|t|u|v|w|x|y|z" )
    For $a = 1 to $split[0]
        For $b = 65 to 90
            If StringInStr( $split[$a] , Chr($b) ) Then
                $split[$a] = StringReplace( $split[$a] , Chr($b), $b )
            EndIf
        Next
        $return &= $split[$a]
    Next
    $return = StringMid(  $return ,  StringLen( $return ) / 2 - 3 , 8 )
    Return $return
EndFunc